Arch Rebar: Difference between revisions

From FreeCAD Documentation
m (Icon)
m (Added icons for the workbenches)
(17 intermediate revisions by 5 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>
{{docnav|[[Arch_Rebar_Helical|Helical Rebar]]|[[Arch_Floor|Floor]]|[[Arch_Module|Arch]]|IconL=Arch_Rebar_Helical.svg |IconC=Workbench_Arch.svg |IconR=Arch_Floor.svg}}
<!--T:1-->
<!--T:1-->
{{docnav
|[[Arch_Rebar_BeamReinforcement|BeamReinforcement]]
|[[Arch_Floor|Floor]]
|[[Arch_Module|Arch]]
|IconL=Arch_Rebar_BeamReinforcement.svg
|IconC=Workbench_Arch.svg
|IconR=Arch_Floor.svg
}}

<!--T:23-->
{{GuiCommand
{{GuiCommand
|Name=Arch Rebar
|Name=Arch Rebar
|MenuLocation=Arch → Rebar
|MenuLocation=Arch → Rebar
|Workbenches=[[Arch Module|Arch]]
|Workbenches=[[Arch Module|Arch]]
|Shortcut=R B
|Shortcut={{KEY|R}} {{KEY|B}}
|SeeAlso=[[Arch Structure|Arch Structure]]
|SeeAlso=[[Arch Structure|Arch Structure]], [[Reinforcement Addon|Reinforcement Addon]]
}}
}}


Line 14: Line 23:


<!--T:3-->
<!--T:3-->
The [[Arch Rebar]] tool allows you to place [http://en.wikipedia.org/wiki/Rebar reinforcing bars] inside [[Arch Structure]] objects.
The [[Arch Rebar|Arch Rebar]] tool allows you to place [http://en.wikipedia.org/wiki/Rebar reinforcing bars] inside [[Arch Structure|Arch Structure]] objects.


<!--T:20-->
Rebar objects are based on 2D profiles such as [[Draft Workbench|Draft objects]] and [[Sketcher Workbench|Sketches]], that must be drawn on a face of the structural object. After creation you can adjust the properties of the rebar, including the number and diameter of the bars, and the offset distance between them and the faces of the structural element.
Rebar objects are based on 2D profiles such as [[Draft Workbench|Draft objects]] and [[Sketcher Workbench|Sketches]], that must be drawn on a face of the structural object. After creation you can adjust the properties of the rebar, including the number and diameter of the bars, and the offset distance between them and the faces of the structural element.


Line 27: Line 37:


<!--T:17-->
<!--T:17-->
The Rebar tool is enhanced by the [[Reinforcement Addon]], which is installed by the [[Addon Manager]]. The additional rebar types available with the addon are:
The Rebar tool is enhanced by the [[Reinforcement Addon|Reinforcement Addon]], which is installed by the [[Addon Manager|Addon Manager]]. The additional rebar types available with the addon are:
* [[Image:Arch_Rebar_Straight.svg|32px]] [[Arch_Rebar_Straight|Straight Rebar]]
* [[Image:Arch_Rebar_Straight.svg|32px]] [[Arch_Rebar_Straight|Straight Rebar]]
* [[Image:Arch_Rebar_UShape.svg|32px]] [[Arch_Rebar_UShape|UShape Rebar]]
* [[Image:Arch_Rebar_UShape.svg|32px]] [[Arch_Rebar_UShape|UShape Rebar]]
Line 35: Line 45:
* [[Image:Arch_Rebar_Helical.svg|32px]] [[Arch_Rebar_Helical|Helical Rebar]]
* [[Image:Arch_Rebar_Helical.svg|32px]] [[Arch_Rebar_Helical|Helical Rebar]]


==How to use== <!--T:6-->
==Usage== <!--T:6-->


<!--T:7-->
<!--T:7-->
# Create an {{Button|[[Image:Arch_Structure.svg|16px]] [[Arch Structure]]}} element.
# Switch to the [[Image:Workbench_Arch.svg|16px]] [[Arch Workbench]]
# Create an {{Button|[[Image:Arch_Structure.svg|16px]] [[Arch Structure|Arch Structure]]}} element.
# Switch to the [[Sketcher Workbench]].
# Switch to the [[Image:Workbench_Sketcher.svg|16px]] [[Sketcher Workbench|Sketcher Workbench]].
# Select one face of the structural element.
# Select one face of the structural element.
# Press the {{Button|[[Image:Sketcher NewSketch.svg|16px]] [[Sketcher NewSketch|New Sketch]]}} button to start a new sketch on the selected face.
# Press the {{Button|[[Image:Sketcher NewSketch.svg|16px]] [[Sketcher NewSketch|New Sketch]]}} button to start a new sketch on the selected face.
# Draw the diagram of your bar.
# Draw the diagram of your bar.
# Press the {{Button|[[Image:Sketcher LeaveSketch.svg|16px]] [[Sketcher LeaveSketch|Leave Sketch]]}} button to finish.
# Press the {{Button|[[Image:Sketcher LeaveSketch.svg|16px]] [[Sketcher LeaveSketch|Leave Sketch]]}} button to finish.
# Switch back to the [[Arch Workbench]].
# Switch back to the [[Image:Workbench_Arch.svg|16px]] [[Arch Workbench]].
# Select the sketch you just drew.
# Select the sketch you just drew.
# Press the {{Button|[[Image:Arch Rebar.svg|16px]] [[Arch Rebar]]}} button, or press {{KEY|R}} then {{KEY|B}} keys.
# Press the {{Button|[[Image:Arch Rebar.svg|16px]] [[Arch Rebar|Arch Rebar]]}} button, or press {{KEY|R}} then {{KEY|B}} keys.
# Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element).
# Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element).

<!--T:24-->
Although normally a rebar is used inside an Arch Structure, since FreeCAD 0.19 the rebar can be created outside of any host object. To host a rebar inside an object, you just need to set its {{PropertyData|Host}}.


==Options== <!--T:8-->
==Options== <!--T:8-->
Line 70: Line 84:


==Scripting== <!--T:12-->
==Scripting== <!--T:12-->
{{Emphasis|See also:}} [[Arch API]] and [[FreeCAD Scripting Basics]].
{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:13-->
<!--T:13-->
The Rebar tool can be used in [[macros]] and from the [[Python]] console by using the following function:
The Rebar tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
</translate>
{{Code|code=
{{Code|code=
Line 81: Line 95:


<!--T:14-->
<!--T:14-->
* Creates a {{incode|Rebar}} object from the given {{incode|baseobj}}, which is an [[Arch Structure]], and a {{incode|sketch}} as profile.
* Creates a {{incode|Rebar}} object from the given {{incode|baseobj}}, which is an [[Arch Structure|Arch Structure]], and a {{incode|sketch}} as profile.
** {{incode|diameter}}, {{incode|amount}}, and {{incode|offset}} are used to define the characteristics of the bars.
** {{incode|diameter}}, {{incode|amount}}, and {{incode|offset}} are used to define the characteristics of the bars.
** If no {{incode|diameter}}, {{incode|amount}}, or {{incode|offset}} values are given, the default values from the [[Arch Preferences]] are used.
** If no {{incode|diameter}}, {{incode|amount}}, or {{incode|offset}} values are given, the default values from the [[Arch Preferences|Arch Preferences]] are used.


<!--T:15-->
<!--T:15-->
Example:
Example:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 109: Line 124:
}}
}}
<translate>
<translate>

<!--T:19-->
<!--T:19-->
{{docnav
{{docnav|[[Arch_Rebar_Helical|Helical Rebar]]|[[Arch_Floor|Floor]]|[[Arch_Module|Arch]]|IconL=Arch_Rebar_Helical.svg |IconC=Workbench_Arch.svg |IconR=Arch_Floor.svg}}
|[[Arch_Rebar_BeamReinforcement|BeamReinforcement]]
{{Arch Tools navi}}
|[[Arch_Floor|Floor]]
{{Userdocnavi}}
|[[Arch_Module|Arch]]
|IconL=Arch_Rebar_BeamReinforcement.svg
|IconC=Workbench_Arch.svg
|IconR=Arch_Floor.svg
}}

</translate>
</translate>
{{Arch Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
[[Category:External Command Reference{{#translation:}}]]
[[Category:Reinforcement{{#translation:}}]]

Revision as of 11:09, 14 June 2020

Arch Rebar

Menu location
Arch → Rebar
Workbenches
Arch
Default shortcut
R B
Introduced in version
-
See also
Arch Structure, Reinforcement Addon

Description

The Arch Rebar tool allows you to place reinforcing bars inside Arch Structure objects.

Rebar objects are based on 2D profiles such as Draft objects and Sketches, that must be drawn on a face of the structural object. After creation you can adjust the properties of the rebar, including the number and diameter of the bars, and the offset distance between them and the faces of the structural element.

Structural object with two sketches drawn on its faces, which are then turned into two sets of rebar objects

Extension available

The Rebar tool is enhanced by the Reinforcement Addon, which is installed by the Addon Manager. The additional rebar types available with the addon are:

Usage

  1. Switch to the Arch Workbench
  2. Create an Arch Structure element.
  3. Switch to the Sketcher Workbench.
  4. Select one face of the structural element.
  5. Press the New Sketch button to start a new sketch on the selected face.
  6. Draw the diagram of your bar.
  7. Press the Leave Sketch button to finish.
  8. Switch back to the Arch Workbench.
  9. Select the sketch you just drew.
  10. Press the Arch Rebar button, or press R then B keys.
  11. Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element).

Although normally a rebar is used inside an Arch Structure, since FreeCAD 0.19 the rebar can be created outside of any host object. To host a rebar inside an object, you just need to set its DataHost.

Options

  • Rebars share the common properties and behaviours of all Arch Components
  • The rounding value is expressed in times the diameter. If your bar has a diameter of 5mm, a rounding value of 3 will create rounding at angles with a radius of 15mm.
  • Default values for new rebars can be set in the Arch preferences settings.
  • If a direction vector is not specified, the direction and distance along which the bars will spread is calculated automatically from the host structural object, by taking the normal direction of the base sketch, and taking its intersection with the structural object. If you specify a direction vector, the length of that vector will also be taken into account.
  • The spacing value is calculated from the current amount of bars, and represents the distance between the axes of each bar. You must therefore subtract the bar diameter to obtain the size of the free space between bars.

Properties

  • DataAmount: The amount of bars.
  • DataDiameter: The diameter of the bars.
  • DataDirection: The direction (and length) along which the bars must spread. If the value is (0,0,0), the direction is calculated automatically from the host structural object.
  • DataOffset Start: The offset distance between the border of the structural object and the first bar.
  • DataOffset End: The offset distance between the border of the structural object and the last bar.
  • DataRounding: A rounding value to be applied to the corners of the bars, expressed in times the diameter.
  • DataSpacing: The distance between the axes of each bar.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Rebar tool can be used in macros and from the Python console by using the following function:

Rebar = makeRebar(baseobj=None, sketch=None, diameter=None, amount=1, offset=None, name="Rebar")
  • Creates a Rebar object from the given baseobj, which is an Arch Structure, and a sketch as profile.
    • diameter, amount, and offset are used to define the characteristics of the bars.
    • If no diameter, amount, or offset values are given, the default values from the Arch Preferences are used.

Example:

import FreeCAD, Arch, Part

Structure = Arch.makeStructure(None, length=1000, width=1000, height=3000)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()

p1 = FreeCAD.Vector(-400, 400, 0)
p2 = FreeCAD.Vector(400, 400, 0)
Sketch = FreeCAD.ActiveDocument.addObject('Sketcher::SketchObject', 'Sketch')
Sketch.MapMode = "FlatFace"
Sketch.Support = [(Structure, "Face6")]
Sketch.addGeometry(Part.LineSegment(p1, p2))
FreeCAD.ActiveDocument.recompute()

Rebar = Arch.makeRebar(Structure, Sketch, diameter=80, amount=7, offset=50)
Rebar.OffsetStart = 100
Rebar.OffsetEnd = 100
FreeCAD.ActiveDocument.recompute()